/*++

Copyright (c) Sydus.

Module:

    Socket.h

Authors:

    Sharvil Nanavati (sharvil) 2005-12-11

--*/

#pragma once

#include "base.h"
#include "ISelectable.h"
#include "ISocketImplementation.h"

enum ENetworkProtocol
{
	KProtocolTcp,
	KProtocolUdp
};

class ISocketImplementation;

class Socket : public ISelectable
{
	public:
		explicit Socket(const ENetworkProtocol & protocol);
		virtual ~Socket();

		virtual void Close();

		void SetBlocking();
		void SetNonBlocking();

		bool IsReadable() const;
		bool IsWritable() const;

		int32 GetFd() const;

	protected:
		Socket(ISocketImplementation * socket);
		ISocketImplementation * GetSocket();
		const ISocketImplementation * GetSocket() const;

	private:
		ISocketImplementation * iSocket;
};
