/*++

Copyright (c) Sydus.

Module:

    UdpClient.cpp

Authors:

    Sharvil Nanavati (sharvil) 2005-12-05

--*/

#pragma once

#include "base.h"
#include "ClientSocket.h"

class InetAddress;

class UdpClient : public ClientSocket
{
	public:
		UdpClient();
		~UdpClient();

		using ClientSocket::Read;
		using ClientSocket::Write;

		uint32 Read(InetAddress & source, void * buffer, uint32 size) const;
		uint32 Write(const InetAddress & destination, const void * buffer, uint32 size) const;

		BString Read(InetAddress & source, uint32 maxLength) const;
		uint32 Write(const InetAddress & destination, const BString & packet) const;
};
