/*++

Copyright (c) Sydus.

Module:

    ByteOrder.h

Authors:

    Sharvil Nanavati (sharvil) 2006-12-03

--*/

#ifndef BYTEORDER_H
#define BYTEORDER_H

#include "base.h"

class LittleEndian : public NonInstantiable
{
	public:
		static void SetInt16(BString & dest, BString::size_type offset, int16 value);
		static void SetInt32(BString & dest, BString::size_type offset, int32 value);

		static void SetUint16(BString & dest, BString::size_type offset, uint16 value);
		static void SetUint32(BString & dest, BString::size_type offset, uint32 value);

		static int16 GetInt16(const BString & source, BString::size_type & offset);
		static int32 GetInt32(const BString & source, BString::size_type & offset);

		static uint16 GetUint16(const BString & source, BString::size_type & offset);
		static uint32 GetUint32(const BString & source, BString::size_type & offset);
};

class BigEndian : public NonInstantiable
{
	public:
		static void SetInt16(BString & dest, BString::size_type offset, int16 value);
		static void SetInt32(BString & dest, BString::size_type offset, int32 value);

		static void SetUint16(BString & dest, BString::size_type offset, uint16 value);
		static void SetUint32(BString & dest, BString::size_type offset, uint32 value);

		static int16 GetInt16(const BString & source, BString::size_type & offset);
		static int32 GetInt32(const BString & source, BString::size_type & offset);

		static uint16 GetUint16(const BString & source, BString::size_type & offset);
		static uint32 GetUint32(const BString & source, BString::size_type & offset);
};

#endif
