/*++

Copyright (c) Sydus.

Module:

	File.h

Authors:

	Sharvil Nanavati (sharvil) 2006-02-20

--*/

#pragma once

#include "base.h"

class File
{
	public:
		enum ESeekMode
		{
			KSeekAbsolute,
			KSeekRelative,
			KSeekReverse
		};

	public:
		static bool Exists(const std::string & filename);
		static uint32 Length(const std::string & filename);
		static uint32 LastModifiedTime(const std::string & filename);

		File();
		~File();

		void Open(const std::string & filename, const std::string & mode);
		void Close();

		bool IsSeekable() const;
		void Seek(int32 offset, ESeekMode seekMode);

		std::string ReadLine() const;

		BString Read(uint32 maxLength) const;
		uint32 Write(const BString & data) const;

		uint32 Read(void * buffer, uint32 size) const;
		uint32 Write(const void * buffer, uint32 size) const;

		bool IsEndOfFile() const;

	private:
		FILE * iFilePointer;
};
